﻿package
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FullScreenEvent;
	import flash.display.DisplayObject;
	
	public class Boussoler extends Sprite
	{
		private var col:uint = 4;
		private var line:uint = 4;
		private var clip:Sprite;
		private var clip2:Sprite;
		private var clip3:Sprite;
		private var angle:Number;
		public function Boussoler()
		{
			addEventListener(Event.ADDED_TO_STAGE, addedHandler);
		}
		private function fullhandler(e:FullScreenEvent):void
		{
			while(numChildren>0){
				var c:DisplayObject = getChildAt(0);
				removeChildAt(0);
				c = null;
			}
			init();
		}
		
		private function addedHandler(e:Event):void
		{
			stage.addEventListener(FullScreenEvent.FULL_SCREEN,fullhandler);
			init();
		}
		private function init():void
		{
			var nbrl:Number = stage.stageWidth/col;
			var nbrh:Number = stage.stageHeight/line;
			for(var i:uint=1;i<line;i++){
				for(var j:uint=1;j<col;j++){
					clip = new Sprite();
					clip.graphics.lineStyle(100,0xffffff);
					clip.graphics.moveTo(0,0);
					clip.graphics.lineTo(0,20);
					clip.x = j*nbrl;
					clip.y = i*nbrh;
					addChild(clip);
					clip.addEventListener(Event.ENTER_FRAME,enterHandler);
				}
			}
			for(var i:uint=1;i<line;i++){
				for(var j:uint=1;j<col;j++){
					clip2 = new Sprite();
					clip2.graphics.lineStyle(50,0x555555);
					clip2.graphics.moveTo(0,0);
					clip2.graphics.lineTo(0,22);
					clip2.x = j*nbrl;
					clip2.y = i*nbrh;
					addChild(clip2);
					clip2.addEventListener(Event.ENTER_FRAME,enterHandler2);
				}
			}
			for(var i:uint=1;i<line;i++){
				for(var j:uint=1;j<col;j++){
					clip3 = new Sprite();
					clip3.graphics.lineStyle(25,0x000000);
					clip3.graphics.moveTo(0,0);
					clip3.graphics.lineTo(0,11);
					clip3.x = j*nbrl;
					clip3.y = i*nbrh;
					addChild(clip3);
					clip3.addEventListener(Event.ENTER_FRAME,enterHandler3);
				}
			}
		}
		
		private function enterHandler(e:Event):void
		{
			angle = Math.atan((e.currentTarget.y-mouseY)/(e.currentTarget.x-mouseX));
			e.currentTarget.rotation = angle*180/Math.PI+Math.sin(angle)*5;
			e.currentTarget.scaleY = angle;
		}
		private function enterHandler2(e:Event):void
		{
			angle = Math.atan((e.currentTarget.y-mouseY)/(e.currentTarget.x-mouseX));
			e.currentTarget.rotation = angle*180/Math.PI+Math.sin(angle)*500;
			e.currentTarget.scaleY = angle;
		}
		private function enterHandler3(e:Event):void
		{
			angle = Math.atan((e.currentTarget.y-mouseY)/(e.currentTarget.x-mouseX));
			e.currentTarget.rotation = angle*180/Math.PI+Math.sin(angle)*1000;
			e.currentTarget.scaleY = angle;
		}
	}
}